Bash functions style cleanup
[csit.git] / resources / libraries / bash / function / device.sh
index 8aeb221..0eda008 100644 (file)
 set -exuo pipefail
 
 # This library defines functions used by multiple entry scripts.
+# Deliberately not depending on common.sh to allow standalone usage.
 # Keep functions ordered alphabetically, please.
 
 function activate_wrapper () {
+
     # Acts as wrapper for activate docker topology.
     #
     # Variables read:
@@ -37,6 +39,7 @@ function activate_wrapper () {
 
 
 function bind_interfaces_to_containers () {
+
     # Bind linux network interface to container and create symlink for PCI
     # address in container.
     #
@@ -83,6 +86,7 @@ function bind_interfaces_to_containers () {
 
 
 function bind_interfaces_to_driver () {
+
     # Bind network interface specified by parameter to driver specified by
     # parameter.
     #
@@ -90,9 +94,11 @@ function bind_interfaces_to_driver () {
     # - ADDR - PCI address of network interface.
     # - DRIVER - Kernel driver.
 
+    set -exuo pipefail
+
     pci_path="/sys/bus/pci/devices/${ADDR}"
     drv_path="/sys/bus/pci/drivers/${DRIVER}"
-    vd="$(cat ${pci_path}/vendor ${pci_path}/device)" || {
+    vd=$(cat ${pci_path}/vendor ${pci_path}/device) || {
         die "Failed to retrieve interface details!"
     }
     set +e
@@ -108,6 +114,7 @@ function bind_interfaces_to_driver () {
 
 
 function clean_environment () {
+
     # Cleanup environment by removing topology containers and shared volumes
     # and binding interfaces back to original driver.
     #
@@ -124,18 +131,12 @@ function clean_environment () {
     # Kill docker containers.
     docker rm --force "${DCR_UUIDS[@]}" || die "Cleanup containers failed!"
 
-    # Check if some container is using volume and remove all the hanged
-    # containers before removing volume. Command will not fail in case there
-    # are no containers to remove.
-    docker rm --force $(docker ps -q --filter volume=${DCR_VOLUMES[dut1]}) || {
+    # Check if there are some leftover containers and remove all. Command will
+    # not fail in case there are no containers to remove.
+    docker rm --force $(docker ps -q --filter name=${DCR_UUIDS[dut1]}) || {
         warn "Failed to remove hanged containers or nothing to remove!"
     }
 
-    # Remove DUT1 volume.
-    docker volume rm --force "${DCR_VOLUMES[dut1]}" || {
-        die "Failed to remove DUT1 volume!"
-    }
-
     # Rebind interfaces back to kernel drivers.
     for ADDR in ${TG_PCIDEVS[@]}; do
         DRIVER="${TG_DRIVERS[0]}"
@@ -149,10 +150,13 @@ function clean_environment () {
 
 
 function clean_environment_on_exit () {
+
     # Cleanup environment by removing topology containers and binding
     # interfaces back to original driver only if exit code is not 0.
     # This function acts as workaround as 'set -eu' does not trigger ERR trap.
 
+    set -exuo pipefail
+
     if [ $? -ne 0 ]; then
         clean_environment || die
     fi
@@ -160,6 +164,7 @@ function clean_environment_on_exit () {
 
 
 function deactivate_wrapper () {
+
     # Acts as wrapper for deactivate docker topology.
     #
     # Variables read:
@@ -175,9 +180,12 @@ function deactivate_wrapper () {
 
 
 function die () {
+
     # Print the message to standard error end exit with error code specified
     # by the second argument.
     #
+    # Duplicate of common.sh function, as this file is also used standalone.
+    #
     # Hardcoded values:
     # - The default error message.
     # Arguments:
@@ -192,6 +200,7 @@ function die () {
 
 
 function enter_mutex () {
+
     # Enter mutual exclusion for protecting execution from starvation and
     # deadlock.
 
@@ -214,6 +223,7 @@ function enter_mutex () {
 
 
 function exit_mutex () {
+
     # Exit mutual exclusion.
 
     set -exuo pipefail
@@ -228,11 +238,12 @@ function exit_mutex () {
 
 
 function get_available_interfaces () {
+
     # Find and get available Virtual functions.
     #
     # Arguments:
-    # - ${1} - Node flavor string, usually describing the processor and node
-    # multiplicity of desired testbed, separated by underscore.
+    # - ${1} - Nodeness, as set by common.sh get_test_code.
+    # - ${2} - Flavor, as set by common.sh get_test_code.
     # Variables set:
     # - DUT1_NETDEVS - List of network devices allocated to DUT1 container.
     # - DUT1_PCIDEVS - List of PCI addresses allocated to DUT1 container.
@@ -263,8 +274,8 @@ function get_available_interfaces () {
             # Add Intel Corporation 82545EM Gigabit Ethernet Controller to the
             # whitelist.
             pci_id="0x100f"
-            tg_netdev=(eth1 eth2)
-            dut1_netdev=(eth3 eth4)
+            tg_netdev=(enpTGa enpTGb)
+            dut1_netdev=(enpSUTa enpSUTb)
             ;;
         *)
             die "Unknown specification: ${case_text}!"
@@ -304,12 +315,26 @@ function get_available_interfaces () {
         fi
     done
 
-    for netdev in "${tg_side[@]::2}"; do
-        TG_NETDEVS+=(${netdev})
-    done
-    for netdev in "${dut1_side[@]::2}"; do
-        DUT1_NETDEVS+=(${netdev})
-    done
+    case "${case_text}" in
+        "1n_skx")
+            # Pick up first two DUT1 interfaces binded to i40evf.
+            for netdev in "${dut1_side[@]::2}"; do
+                DUT1_NETDEVS+=(${netdev})
+            done
+            # Corresponding TG interfaces will be same ID.SUB_ID, but on
+            # opposite linked device.
+            for netdev in "${DUT1_NETDEVS[@]}"; do
+                TG_NETDEVS+=(${netdev/$dut1_netdev/$tg_netdev})
+            done
+            ;;
+        *)
+            for netdev in "${tg_side[@]::2}"; do
+                TG_NETDEVS+=(${netdev})
+            done
+            for netdev in "${dut1_side[@]::2}"; do
+                DUT1_NETDEVS+=(${netdev})
+            done
+    esac
 
     for NETDEV in "${TG_NETDEVS[@]}"; do
         get_pci_addr
@@ -339,6 +364,7 @@ function get_available_interfaces () {
 
 
 function get_krn_driver () {
+
     # Get kernel driver from linux network device name.
     #
     # Variables read:
@@ -356,6 +382,7 @@ function get_krn_driver () {
 
 
 function get_mac_addr () {
+
     # Get MAC address from linux network device name.
     #
     # Variables read:
@@ -374,6 +401,7 @@ function get_mac_addr () {
 
 
 function get_pci_addr () {
+
     # Get PCI address in <domain>:<bus:<device>.<func> format from linux network
     # device name.
     #
@@ -397,34 +425,41 @@ function get_pci_addr () {
 
 function installed () {
 
-    set -exuo pipefail
-
     # Check if the given utility is installed. Fail if not installed.
     #
+    # Duplicate of common.sh function, as this file is also used standalone.
+    #
     # Arguments:
     # - ${1} - Utility to check.
     # Returns:
     # - 0 - If command is installed.
     # - 1 - If command is not installed.
 
+    set -exuo pipefail
+
     command -v "${1}"
 }
 
 
 function print_env_variables () {
+
     # Get environment variables prefixed by CSIT_.
 
     set -exuo pipefail
 
-    env | grep CSIT_
+    env | grep CSIT_ || true
 }
 
 
 function read_env_variables () {
+
     # Read environment variables from parameters.
     #
     # Arguments:
     # - ${@} - Variables passed as an argument.
+    # Variables read, set or exported: Multiple,
+    # see the code for the current list.
+    # TODO: Do we need to list them and their meanings?
 
     set -exuo pipefail
 
@@ -432,10 +467,8 @@ function read_env_variables () {
         export "${param}"
     done
     declare -gA DCR_UUIDS
-    declare -gA DCR_VOLUMES
     DCR_UUIDS+=([tg]="${CSIT_TG_UUID}")
     DCR_UUIDS+=([dut1]="${CSIT_DUT1_UUID}")
-    DCR_VOLUMES+=([dut1]="${CSIT_DUT1_VOL}")
     TG_PCIDEVS=("${CSIT_TG_INTERFACES_PORT1_PCI}")
     TG_DRIVERS=("${CSIT_TG_INTERFACES_PORT1_DRV}")
     TG_PCIDEVS+=("${CSIT_TG_INTERFACES_PORT2_PCI}")
@@ -448,6 +481,7 @@ function read_env_variables () {
 
 
 function set_env_variables () {
+
     # Set environment variables.
     #
     # Variables read:
@@ -459,6 +493,7 @@ function set_env_variables () {
     # - TG_NETMACS - List of network devices MAC addresses of TG container.
     # - TG_PCIDEVS - List of PCI addresses of devices of TG container.
     # - TG_DRIVERS - List of interface drivers to TG container.
+    # Variables set: TODO.
 
     set -exuo pipefail
 
@@ -479,7 +514,6 @@ function set_env_variables () {
     CSIT_DUT1_ARCH="$(uname -i)" || {
         die "Reading machine architecture failed!"
     }
-    CSIT_DUT1_VOL="${DCR_VOLUMES[dut1]}"
     CSIT_TG_INTERFACES_PORT1_MAC="${TG_NETMACS[0]}"
     CSIT_TG_INTERFACES_PORT1_PCI="${TG_PCIDEVS[0]}"
     CSIT_TG_INTERFACES_PORT1_DRV="${TG_DRIVERS[0]}"
@@ -497,6 +531,7 @@ function set_env_variables () {
 
 
 function start_topology_containers () {
+
     # Starts csit-sut-dcr docker containers for TG/DUT1.
     #
     # Variables read:
@@ -543,26 +578,14 @@ function start_topology_containers () {
     declare -gA DCR_PORTS
     # Docker Container PIDs (namespaces).
     declare -gA DCR_CPIDS
-    # Docker Container volumes with no relationship to the host.
-    declare -gA DCR_VOLUMES
-
-    # Create DUT1 /tmp volume to be able to install VPP in "nested" container.
-    params=(--name DUT1_VOL_$(uuidgen))
-    DCR_VOLUMES+=([dut1]="$(docker volume create "${params[@]}")") || {
-        die "Failed to create DUT1 /tmp volume!"
-    }
-
-    # Mount DUT1_VOL as /tmp directory on DUT1 container
-    dcr_stc_params_dut1="--volume ${DCR_VOLUMES[dut1]}:/tmp "
 
     # Run TG and DUT1. As initial version we do support only 2-node.
     params=(${dcr_stc_params} --name csit-tg-$(uuidgen) ${dcr_image})
-    DCR_UUIDS+=([tg]="$(docker run "${params[@]}")") || {
+    DCR_UUIDS+=([tg]=$(docker run "${params[@]}")) || {
         die "Failed to start TG docker container!"
     }
-    params=(${dcr_stc_params} ${dcr_stc_params_dut1}
-            --name csit-dut1-$(uuidgen) ${dcr_image})
-    DCR_UUIDS+=([dut1]="$(docker run "${params[@]}")") || {
+    params=(${dcr_stc_params} --name csit-dut1-$(uuidgen) ${dcr_image})
+    DCR_UUIDS+=([dut1]=$(docker run "${params[@]}")) || {
         die "Failed to start DUT1 docker container!"
     }
 
@@ -572,21 +595,21 @@ function start_topology_containers () {
 
     # Get Containers TCP ports.
     params=(${DCR_UUIDS[tg]})
-    DCR_PORTS+=([tg]="$(docker port "${params[@]}")") || {
+    DCR_PORTS+=([tg]=$(docker port "${params[@]}")) || {
         die "Failed to get port of TG docker container!"
     }
     params=(${DCR_UUIDS[dut1]})
-    DCR_PORTS+=([dut1]="$(docker port "${params[@]}")") || {
+    DCR_PORTS+=([dut1]=$(docker port "${params[@]}")) || {
         die "Failed to get port of DUT1 docker container!"
     }
 
     # Get Containers PIDs.
     params=(--format="{{ .State.Pid }}" ${DCR_UUIDS[tg]})
-    DCR_CPIDS+=([tg]="$(docker inspect "${params[@]}")") || {
+    DCR_CPIDS+=([tg]=$(docker inspect "${params[@]}")) || {
         die "Failed to get PID of TG docker container!"
     }
     params=(--format="{{ .State.Pid }}" ${DCR_UUIDS[dut1]})
-    DCR_CPIDS+=([dut1]="$(docker inspect "${params[@]}")") || {
+    DCR_CPIDS+=([dut1]=$(docker inspect "${params[@]}")) || {
         die "Failed to get PID of DUT1 docker container!"
     }
 }
@@ -594,8 +617,12 @@ function start_topology_containers () {
 function warn () {
     # Print the message to standard error.
     #
+    # Duplicate of common.sh function, as this file is also used standalone.
+    #
     # Arguments:
     # - ${@} - The text of the message.
 
+    set -exuo pipefail
+
     echo "$@" >&2
 }